package com.muyu.eventdriven.controller;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.muyu.eventdriven.domain.rest.Result;
import com.muyu.eventdriven.server.EventInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * @ClassName EventInfoController
 * @Description 事件信息控制层
 * @Author Yunfei.Du
 * @Date 2024/6/16 下午3:58
 */
@RestController
@RequestMapping("/eventInfo")
public class EventInfoController {
    @Autowired
    private EventInfoService eventInfoService;

    @GetMapping("/CreatKafkaConsumer")
    public void creatKafkaConsumer(@RequestParam("vin") String vin) throws JsonProcessingException {
        eventInfoService.creatKafkaConsumer(vin);
    }

    @GetMapping("/CloseKafkaConsumer")
    public Result closeKafkaConsumer(@RequestParam("vin") String vin) {
        return eventInfoService.closeKafkaConsumer(vin);
    }
}
