package com.muyu.eventdriven.tactics.system;

import com.muyu.eventdriven.domain.VehicleData;
import com.muyu.eventdriven.tactics.EventTactics;
import lombok.extern.log4j.Log4j2;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @ClassName ElectronicFenceEvent
 * @Description 电子围栏
 * @Author Yunfei.Du
 * @Date 2024/6/20 上午10:42
 */
@Service("ElectronicFenceEvent")
@Log4j2
public class ElectronicFenceEvent implements EventTactics {
    /**
     * 单条数据的处理
     * @param vehicleData
     */
    @Override
    public void eventManage(VehicleData vehicleData) {
        log.info("车辆{}执行电子围栏事件",vehicleData.getVin());
    }

    /**
     * 多条数据的处理
     * @param vin
     * @param vehicleDataList
     */
    @Override
    public void eventManage(String vin, List<VehicleData> vehicleDataList) {
        log.info("车辆{}执行电子围栏事件",vin);
    }
}
