package com.muyu.eventdriven.tactics.system;

import com.muyu.eventdriven.domain.VehicleData;
import com.muyu.eventdriven.tactics.EventTactics;
import lombok.extern.log4j.Log4j2;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @ClassName IndexWarningEvent
 * @Description 指标预警
 * @Author Yunfei.Du
 * @Date 2024/6/20 上午11:00
 */
@Service("IndexWarningEvent")
@Log4j2
public class IndexWarningEvent implements EventTactics {
    @Override
    public void eventManage(VehicleData vehicleData) {
        log.info("车辆{}执行指标预警事件",vehicleData.getVin());
    }

    @Override
    public void eventManage(String vin, List<VehicleData> vehicleDataList) {
        log.info("车辆{}执行指标预警事件",vin);
    }
}
